// Macro limitation: any expressions with commas will need "()" around the whole expression

// BLKPred1 - a function returning boolean, with one parameter called p1 of type id
// BLKPredS - a function returning boolean, with one parameter called p1 of type NSString
// BLKPredN - a function returning boolean, with one parameter called p1 of type NSNumber
#define BLKPred1(expr) ^BOOL(id p1){return expr;}
#define BLKPredS(expr) ^BOOL(NSString *p1){return expr;}
#define BLKPredN(expr) ^BOOL(NSNumber *p1){return expr;}

// single parameters. Parameter name is p1, return type is the expression's return type
#define BLKFn1(expr) ^(id p1){return expr;}
#define BLKFnS(expr) ^(NSString *p1){return expr;}
#define BLKFnN(expr) ^(NSNumber *p1){return expr;}

// two parameters named, p1, p2
#define BLKFn2(expr) ^(id p1, id p2){return expr;}
#define BLKFnSS(expr) ^(NSString *p1, NSString *p2){return expr;}
#define BLKFnNN(expr) ^(NSNumber *p1, NSNumber *p2){return expr;}

//two parameters. Array as first parameter
#define BLKFnAS(expr) ^(NSMutableArray *p1, NSString *p2){return expr;}
#define BLKFnAN(expr) ^(NSMutableArray *p1, NSNumber *p2){return expr;}

