#import <Foundation/Foundation.h>
#import "BLKFunction.h"

@interface NSArray (BLKArray)

#pragma mark - Return mutable collections or objects

- (NSMutableArray *)blk_take:(NSUInteger)nrToTake;

- (NSMutableArray *)blk_drop:(NSUInteger)nrToDrop;

- (NSMutableArray *)blk_filter:(BLKTypePred1)block;

- (NSMutableArray *)blk_map:(BLKTypeFn1)block;

- (id)blk_reduce:(BLKTypeFn2)block;

- (id)blk_fold:(id)accumulator with:(BLKTypeFn2)block;

- (id)blk_conjoin:(id)cage1;

- (id)blk_conjoin:(id)cage1 and:(id)cage2;

- (id)blk_conjoin:(id)cage1 interpose:(id)theInterpose;

- (id)blk_conjoin:(id)cage1 interleave:(NSArray *)theInterleave;

@end