#import <XCTest/XCTest.h>
#import <BLKFunctional/BLKCatFunction.h>

@interface BLKTestVarious : XCTestCase
@end

@implementation BLKTestVarious

- (void)testTakeDrop {
    NSArray *numberArray = @[@2, @9, @66];

    NSArray *theTest;
    theTest = [numberArray blk_take:2];
    XCTAssertEqualObjects(theTest, (@[@2, @9]), @"take 2");

    theTest = [numberArray blk_drop:2];
    XCTAssertEqualObjects(theTest, (@[@66]), @"drop 2");
}

- (void)testShuffleReverse {
    NSArray *numberArray = @[@2, @9, @66];

    NSArray *theTest;
    theTest = [BLKFunction shuffleArray:numberArray];
    XCTAssertTrue([theTest count] == numberArray.count,"non deterministic function");

    theTest = [BLKFunction reverseArray:numberArray];
    XCTAssertEqualObjects(theTest, (@[@66, @9, @2]), @"reverse");
}

@end
