#import <XCTest/XCTest.h>
#import <BLKFunctional/BLKCatFunction.h>

@interface BLKTestFold : XCTestCase
@end

@implementation BLKTestFold

- (void)testFold {
    NSArray *stringArray = @[@"one", @"two", @"three"];
    NSArray *numberArray = @[@2, @9, @66];
    id theTest;

    // Fold
    theTest = [numberArray blk_fold:@2 with:BLKFn2(@([p1 doubleValue] + [p2 doubleValue])) ];
    XCTAssertEqualObjects(theTest, @79, @"p1 + p2");

    theTest = [numberArray blk_fold:@[] with:BLKFnAN(@[p2]) ];
    XCTAssertEqualObjects(theTest, @[@66], @"last eleme@nt");

    theTest = [stringArray blk_fold:@[@"start"] with:BLKFnAS([p1 arrayByAddingObject:p2]) ];
    XCTAssertEqualObjects(theTest, (@[@"start", @"one", @"two", @"three"]), @"conjoin elements");
}

@end