#import <XCTest/XCTest.h>
#import <BLKFunctional/BLKCatFunction.h>

/**
* Tests for long versions of the Function methods, just to confirm they are correctly defined. Most of
 * the testing will done against the shorter method signatures.
* There are no macros to test.
*/
@interface BlkTestDictionary : XCTestCase

@end

@implementation BlkTestDictionary

- (void)testDictionary {
    id theTest = [BLKFunction foldDictionary:@{@3 : @4} usingOptions:0 toAccumulator:@[]
                            withIndexedBlock:^(id acc, NSNumber *obj1, NSNumber *obj2, NSUInteger idx) {
                                acc = @(obj1.doubleValue + obj2.doubleValue);
                                return acc;
                            }];
    XCTAssertEqualObjects(theTest, @7, @"Add dictionary keys and values");
}

@end
